Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 15764)
@@ -797,39 +949,139 @@
          DO jtype = 1, nsurftypes
 
-            nvarssurf(jtype) = 1
-            nextrsurf(jtype) = 0
-            IF ( TRIM(cobstypessurf(jtype)) == 'sla' ) nextrsurf(jtype) = 2
+            ltype_clim = .FALSE. 
+            IF ( ln_output_clim .AND. & 
+               & ( ( TRIM(cobstypessurf(jtype)) == 'sst' ) .OR. & 
+               &   ( TRIM(cobstypessurf(jtype)) == 'sss' ) ) ) & 
+               & ltype_clim = .TRUE. 
+
+            IF ( (TRIM(cobstypessurf(jtype)) == 'sla') .OR. & 
+               & (TRIM(cobstypessurf(jtype)) == 'sit') .OR. & 
+               & (TRIM(cobstypessurf(jtype)) == 'fbd') ) THEN 
+               nvarssurf(jtype) = 1 
+               nextrsurf(jtype) = 2 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'ssv' ) THEN 
+               nvarssurf(jtype) = 2 
+               nextrsurf(jtype) = 0 
+            ELSE 
+               nvarssurf(jtype) = 1 
+               nextrsurf(jtype) = 0 
+            ENDIF 
+
+            ALLOCATE( clvars( nvarssurf(jtype) ) ) 
+            CALL wrk_alloc( jpi, jpj, nvarssurf(jtype), zglam ) 
+            CALL wrk_alloc( jpi, jpj, nvarssurf(jtype), zgphi ) 
+            CALL wrk_alloc( jpi, jpj, nvarssurf(jtype), zmask_surf ) 
+  
+            IF ( TRIM(cobstypessurf(jtype)) == 'ssv' ) THEN 
+               zglam(:,:,1) = glamu(:,:) 
+               zglam(:,:,2) = glamv(:,:) 
+               zgphi(:,:,1) = gphiu(:,:) 
+               zgphi(:,:,2) = gphiv(:,:) 
+               zmask_surf(:,:,1) = umask(:,:,1) 
+               zmask_surf(:,:,2) = vmask(:,:,1) 
+            ELSE             
+               DO jvar = 1, nvarssurf(jtype) 
+                  zglam(:,:,jvar) = glamt(:,:) 
+                  zgphi(:,:,jvar) = gphit(:,:) 
+                  zmask_surf(:,:,jvar) = tmask(:,:,1)                                        
+               END DO
+            ENDIF
+
+            IF ( TRIM(cobstypessurf(jtype)) == 'sla' ) THEN 
+               clvars(1) = 'SLA' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'sst' ) THEN 
+               clvars(1) = 'SST' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'sic' ) THEN 
+               clvars(1) = 'ICECONC' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'fbd' ) THEN 
+               clvars(1) = 'FBD' 
+               ln_seaicetypes = .TRUE. 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'sit' ) THEN 
+               clvars(1) = 'SIT' 
+               ln_seaicetypes = .TRUE. 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'sss' ) THEN 
+               clvars(1) = 'SSS' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'ssv' ) THEN 
+               clvars(1) = 'UVEL' 
+               clvars(2) = 'VVEL'            
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'slchltot' ) THEN 
+               clvars(1) = 'SLCHLTOT' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'slchldia' ) THEN 
+               clvars(1) = 'SLCHLDIA' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'slchlnon' ) THEN 
+               clvars(1) = 'SLCHLNON' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'slchldin' ) THEN 
+               clvars(1) = 'SLCHLDIN' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'slchlmic' ) THEN 
+               clvars(1) = 'SLCHLMIC' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'slchlnan' ) THEN 
+               clvars(1) = 'SLCHLNAN' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'slchlpic' ) THEN 
+               clvars(1) = 'SLCHLPIC' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'schltot' ) THEN 
+               clvars(1) = 'SCHLTOT' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'slphytot' ) THEN 
+               clvars(1) = 'SLPHYTOT' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'slphydia' ) THEN 
+               clvars(1) = 'SLPHYDIA' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'slphynon' ) THEN 
+               clvars(1) = 'SLPHYNON' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'sspm' ) THEN 
+               clvars(1) = 'SSPM' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'skd490' ) THEN 
+               clvars(1) = 'SKD490' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'sfco2' ) THEN 
+               clvars(1) = 'SFCO2' 
+            ELSE IF ( TRIM(cobstypessurf(jtype)) == 'spco2' ) THEN 
+               clvars(1) = 'SPCO2' 
+            ENDIF
 
             !Read in surface obs types
-            CALL obs_rea_surf( surfdata(jtype), ifilessurf(jtype), &
-               &               clsurffiles(jtype,1:ifilessurf(jtype)), &
-               &               nvarssurf(jtype), nextrsurf(jtype), nitend-nit000+2, &
-               &               rn_dobsini, rn_dobsend, ln_ignmis, .FALSE., llnightav(jtype) )
-
-            CALL obs_pre_surf( surfdata(jtype), surfdataqc(jtype), ln_nea, ln_bound_reject )
-
-            IF ( TRIM(cobstypessurf(jtype)) == 'sla' ) THEN
-               CALL obs_rea_mdt( surfdataqc(jtype), n2dintsurf(jtype) )
-               IF ( ln_altbias ) &
-                  & CALL obs_rea_altbias ( surfdataqc(jtype), n2dintsurf(jtype), cn_altbiasfile )
-            ENDIF
-
-            IF ( TRIM(cobstypessurf(jtype)) == 'sst' .AND. ln_sstbias ) THEN
-               jnumsstbias = 0
-               DO jfile = 1, jpmaxnfiles
-                  IF ( TRIM(cn_sstbiasfiles(jfile)) /= '' ) &
-                     &  jnumsstbias = jnumsstbias + 1
-               END DO
-               IF ( jnumsstbias == 0 ) THEN
-                  CALL ctl_stop("ln_sstbias set but no bias files to read in")    
+            CALL obs_rea_surf( surfdata(jtype), ifilessurf(jtype), & 
+               &               clsurffiles(jtype,1:ifilessurf(jtype)), & 
+               &               nvarssurf(jtype), nextrsurf(jtype), nitend-nit000+2, & 
+               &               rn_dobsini, rn_dobsend, MeanPeriodHours, ln_ignmis, .FALSE., & 
+               &               llnightav(jtype), ltype_clim, ln_time_mean_sla_bkg, clvars ) 
+ 
+            CALL obs_pre_surf( surfdata(jtype), surfdataqc(jtype), & 
+               &               jpi, jpj, &             
+               &               zmask_surf, zglam, zgphi, & 
+               &               ln_nea, ln_bound_reject, ln_seaicetypes ) 
+ 
+            IF ( TRIM(cobstypessurf(jtype)) == 'sla' ) THEN 
+               CALL obs_rea_mdt( surfdataqc(jtype), n2dintsurf(jtype) ) 
+               IF ( ln_altbias ) & 
+                  & CALL obs_rea_altbias ( surfdataqc(jtype), n2dintsurf(jtype), cn_altbiasfile ) 
+            ENDIF 
+ 
+#if defined key_cice 
+            IF ( TRIM(cobstypessurf(jtype)) == 'fbd' ) THEN 
+               CALL obs_rea_snowdepth( surfdataqc(jtype), n2dintsurf(jtype), thick_s(:,:) ) 
+            ENDIF  
+#endif 
+ 
+            IF ( TRIM(cobstypessurf(jtype)) == 'sst' .AND. ln_sstbias ) THEN 
+               jnumsstbias = 0 
+               DO jfile = 1, jpmaxnfiles 
+                  IF ( TRIM(cn_sstbiasfiles(jfile)) /= '' ) & 
+                     &  jnumsstbias = jnumsstbias + 1 
+               END DO 
+               IF ( jnumsstbias == 0 ) THEN 
+                  CALL ctl_stop("ln_sstbias set but no bias files to read in")     
+ 
                ENDIF
 
-               CALL obs_app_sstbias( surfdataqc(jtype), n2dintsurf(jtype), & 
-                  &                  jnumsstbias, cn_sstbiasfiles(1:jnumsstbias) ) 
-
-            ENDIF
-
-         END DO
-
+               CALL obs_app_sstbias( surfdataqc(jtype), n2dintsurf(jtype), &  
+                  &                  jnumsstbias, cn_sstbiasfiles(1:jnumsstbias) )  
+ 
+            ENDIF 
+             
+            DEALLOCATE( clvars ) 
+            CALL wrk_dealloc( jpi, jpj, nvarssurf(jtype), zglam ) 
+            CALL wrk_dealloc( jpi, jpj, nvarssurf(jtype), zgphi ) 
+            CALL wrk_dealloc( jpi, jpj, nvarssurf(jtype), zmask_surf ) 
+ 
+         END DO 
+ 
          DEALLOCATE( ifilessurf, clsurffiles )
 
@@ -879,38 +1131,38 @@
          & frld
 #endif
-#if defined key_cice
-      USE sbc_oce, ONLY : fr_i     ! ice fraction
-#endif
-#if defined key_top
-      USE trc, ONLY :  &           ! Biogeochemical state variables
-         & trn
-#endif
-#if defined key_hadocc
-      USE par_hadocc               ! HadOCC parameters
-      USE trc, ONLY :  &
-         & HADOCC_CHL, &
-         & HADOCC_FCO2, &
-         & HADOCC_PCO2, &
-         & HADOCC_FILL_FLT
-      USE had_bgc_const, ONLY: c2n_p
-#elif defined key_medusa
-      USE par_medusa               ! MEDUSA parameters
-      USE sms_medusa, ONLY: &
-         & xthetapn, &
-         & xthetapd
-#if defined key_roam
-      USE sms_medusa, ONLY: &
-         & f2_pco2w, &
-         & f2_fco2w, &
-         & f3_pH
-#endif
-#elif defined key_fabm
-      USE par_fabm                 ! FABM parameters
-      USE fabm, ONLY: &
-         & fabm_get_interior_diagnostic_data
-#endif
-#if defined key_spm
-      USE par_spm, ONLY: &         ! Sediment parameters
-         & jp_spm
+#if defined key_cice 
+      USE sbc_oce, ONLY : &        ! CICE variables 
+         & fr_i,          &        ! ice fraction 
+         & thick_i                 ! ice thickness 
+#endif 
+#if defined key_top 
+      USE trc, ONLY :  &           ! Biogeochemical state variables 
+         & trn 
+#endif 
+#if defined key_hadocc 
+      USE par_hadocc               ! HadOCC parameters 
+      USE trc, ONLY :  & 
+         & HADOCC_CHL, & 
+         & HADOCC_FCO2, & 
+         & HADOCC_PCO2, & 
+         & HADOCC_FILL_FLT 
+      USE had_bgc_const, ONLY: c2n_p 
+#elif defined key_medusa 
+      USE par_medusa               ! MEDUSA parameters 
+      USE sms_medusa, ONLY: & 
+         & xthetapn, & 
+         & xthetapd 
+#if defined key_roam 
+      USE sms_medusa, ONLY: & 
+         & f2_pco2w, & 
+         & f2_fco2w, & 
+         & f3_pH 
+#endif 
+#elif defined key_fabm 
+      USE par_fabm                 ! FABM parameters 
+#endif 
+#if defined key_spm 
+      USE par_spm, ONLY: &         ! Sediment parameters 
+         & jp_spm 
 #endif
 
@@ -920,23 +1172,26 @@
       INTEGER, INTENT(IN) :: kstp  ! Current timestep
       !! * Local declarations
-      INTEGER :: idaystp           ! Number of timesteps per day
-      INTEGER :: jtype             ! Data loop variable
-      INTEGER :: jvar              ! Variable number
-      INTEGER :: ji, jj, jk        ! Loop counters
-      REAL(wp) :: tiny             ! small number
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: &
-         & zprofvar                ! Model values for variables in a prof ob
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: &
-         & zprofmask               ! Mask associated with zprofvar
-      REAL(wp), POINTER, DIMENSION(:,:) :: &
-         & zsurfvar, &             ! Model values equivalent to surface ob.
-         & zsurfmask               ! Mask associated with surface variable
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: &
-         & zglam,    &             ! Model longitudes for prof variables
-         & zgphi                   ! Model latitudes for prof variables
-      LOGICAL :: llog10            ! Perform log10 transform of variable
-#if defined key_fabm
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: &
-         & pco2_3d                 ! 3D pCO2 from FABM
+      INTEGER :: idaystp           ! Number of timesteps per day 
+      INTEGER :: imeanstp          ! Number of timesteps for sla averaging 
+      INTEGER :: jtype             ! Data loop variable 
+      INTEGER :: jvar              ! Variable number 
+      INTEGER :: ji, jj, jk        ! Loop counters 
+      REAL(wp) :: tiny             ! small number 
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: & 
+         & zprofvar, &             ! Model values for variables in a prof ob 
+         & zprofclim               ! Climatology values for variables in a prof ob 
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: & 
+         & zprofmask               ! Mask associated with zprofvar 
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: & 
+         & zsurfvar, &             ! Model values equivalent to surface ob. 
+         & zsurfclim, &            ! Climatology values for variables in a surface ob. 
+         & zsurfmask               ! Mask associated with surface variable 
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: & 
+         & zglam,    &             ! Model longitudes 
+         & zgphi                   ! Model latitudes 
+      LOGICAL :: llog10            ! Perform log10 transform of variable 
+#if defined key_fabm 
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: & 
+         & fabm_3d                 ! 3D variable from FABM 
 #endif
 
